import xml.etree.ElementTree as ET 

from .delvisKorrEgenskaperCase import DelvisKorrEgenskaperCase

class CustomDelvisKorrReplaceParent(DelvisKorrEgenskaperCase):
    def __init__(self, token, data, extra):
        super().__init__(token, data, extra)
        pass
    
    #aditional method
    def make_XMLRelation_road_object(self, vegobjekt, old_parent_nvdbid: int = int(), 
                                    new_parent_nvdbid: int = int(), operation_type: str = str()):
                                        
        #checking if parent nvdbid to use is old or the new one
        parent_nvdbid = old_parent_nvdbid if old_parent_nvdbid != 0 else new_parent_nvdbid
        
        # checking and assigning slett or ny operasjon
        operation = operation_type if operation_type == 'slett' else 'ny'
        
        vegobjekt = ET.SubElement(vegobjekt, 'vegobjekt')
        
        vegobjekt.attrib = {'typeId':  str(self.extra['nvdb_object_type']), 
                                    'nvdbId': str(parent_nvdbid), 
                                    'versjon':  str(self.modified_data['versjon'])
                                }
        
        validering_objekt = ET.SubElement(vegobjekt, 'validering')
        lest_fra_nvdb = ET.SubElement(validering_objekt, 'lestFraNvdb')
        lest_fra_nvdb.text = self.extra['sistmodifisert']
        
        '''
        adding relations to the parent road object
            
        Note: when adding relation to a road object, convention is that
        parent object must add child as a relation to it and not the other way around.
        '''
        relations = self.extra['relation']

        if relations: 
                
            relations_egenskap = ET.SubElement(vegobjekt, 'assosiasjoner')
                
            for enum_catalog_type_nvdb, item in relations.items():
                #Note: for each relation or assosiasjon a sub or new assosiasjon must be added individual if need it.
                    
                #remove existing child
                relation = ET.SubElement(relations_egenskap, 'assosiasjon')
                relation.attrib = {'typeId': str(enum_catalog_type_nvdb), 'operasjon': 'oppdater'}
                    
                sub_remove_relation = ET.SubElement(relation, 'nvdbId')
                sub_remove_relation.attrib = { 'operasjon':  operation }

                sub_remove_relation.text = str( str( self.extra['replace_child_nvdbid'] ) )
        
        # return vegobjekt
    
    #override method
    def formXMLRequest(self, active_egenskap=True):

        root = ET.Element('endringssett')
        root.attrib = {'xmlns': 'http://nvdb.vegvesen.no/apiskriv/domain/changeset/v3'}

        nvdb_object_id = str(self.modified_data['nvdbid'])
        version = str(self.modified_data['versjon'])
        nvdb_object_type = str(self.extra['nvdb_object_type'])
            
        datakatalogversjon = ET.SubElement(root, 'datakatalogversjon')
        datakatalogversjon.text = self.extra['datakatalog_version']
            
        ansvarlig = ET.SubElement(root, 'ansvarlig')
        ansvarlig.text = self.extra['username']
            
        delvisKorriger = ET.SubElement(root, 'delvisKorriger')
        vegobjekter = ET.SubElement(delvisKorriger, 'vegobjekter')
        
        #making a vegobjekt with ny relation operation
        self.make_XMLRelation_road_object(vegobjekter, 0, self.extra['target_parent_remove'], 'slett')
        
        #making a vegobjekt with slett relation operation
        self.make_XMLRelation_road_object(vegobjekter, self.extra['target_parent_add'], 'ny')
        
        self.xml_string = ET.tostring(root, encoding='utf-8') #be carefull with the unicode

        print(self.xml_string) #debuging info of hole formed XML endingsett

        self.endringsett_form_done.emit()